// IB25Decoder.h: IB25Decoder NX̃C^[tFCX
//
// IB25Decoder : ̐l݊(IWiB25DecorderƓ)
// IB25DecoderEx : Marumo݊̈׊g
//////////////////////////////////////////////////////////////////////

#if !defined(_IB25DECORDER_H_)
#define _IB25DECORDER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


// B25fR[_C^tF[X(gc[̒̐l݊)
class IB25Decoder
{
public:
	virtual const BOOL Initialize(DWORD dwRound = 4) = 0;
	virtual void Release(void) = 0;

	virtual const BOOL Decode(BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize) = 0;
	virtual const BOOL Flush(BYTE **ppDstBuf, DWORD *pdwDstSize) = 0;
	virtual const BOOL Reset(void) = 0;
};

#define B25_DECORD_SUCCESS		0
#define B25_DECORD_PUT_ERROR	-1
#define B25_DECORD_GET_ERROR	-2
#define B25_DECORD_FAILED		-99

#define B25_OPTION_EMM			1
#define B25_OPTION_STRIP		0

// B25fR[_C^tF[X(Marumo݊+)
class IB25DecoderEx
{
public:
	virtual const BOOL SetOpeion(DWORD dwOpt,DWORD dwData) = 0;
	virtual const BOOL Initialize(DWORD dwRound = 4) = 0;
	virtual void Release(void) = 0;

	virtual const DWORD Decode(BYTE *pSrcBuf, const DWORD dwSrcSize, BYTE **ppDstBuf, DWORD *pdwDstSize) = 0;
	virtual const BOOL Flush(BYTE **ppDstBuf, DWORD *pdwDstSize) = 0;
	virtual const BOOL Reset(void) = 0;
};


// CX^X\bh
extern "C" __declspec(dllimport) DWORD GetB25Version(void);
extern "C" __declspec(dllimport) IB25Decoder * CreateB25Decoder(void);
extern "C" __declspec(dllimport) IB25DecoderEx * CreateB25DecoderEx(void);


#endif // !defined(_IB25DECORDER_H_)
